//  RW Foundations
// ================
// The RW Foundational Libraries

// Filename: ./include/incls_all.hpp
// -The following lines pull in the project's real *.hpp files.

#pragma once

#include <algorithm>
#include <cctype>
#include <chrono>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <filesystem>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <ratio>
#include <regex>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <string>
#include <tuple>
#include <vector>

namespace fs = std::filesystem;

using std::any_of;
using std::begin;
using std::cbegin;
using std::cend;
using std::cerr;
using std::cout;
using std::dec;
using std::end;
using std::exception;
using std::find_if;
using std::fixed;
using std::flush;
using std::for_each;
using std::fstream;
using std::getline;
using std::hex;
using std::ifstream;
using std::ios;
using std::locale;
using std::make_tuple;
using std::make_unique;
using std::map;
using std::ofstream;
using std::ostream;
using std::ostringstream;
using std::out_of_range;
using std::putchar;
using std::puts;
using std::ratio;
using std::regex;
using std::regex_match;
using std::round;
using std::runtime_error;
using std::set;
using std::setfill;
using std::setprecision;
using std::setw;
using std::sort;
using std::stack;
using std::stoi;
using std::stoul;
using std::string;
using std::stringstream;
using std::to_string;
using std::tuple;
using std::unique_ptr;
using std::vector;
using std::chrono::duration;
using std::chrono::duration_cast;
using std::chrono::hours;
using std::chrono::microseconds;
using std::chrono::milliseconds;
using std::chrono::minutes;
using std::chrono::nanoseconds;
using std::chrono::seconds;
using std::chrono::system_clock;
using std::chrono::time_point;

///

#include "extern_incls_all.hpp"

using Json = nlohmann::json;

//------------------------------------------------------------------------------
// THE RW 'SWITCHBOARD:A' - library class' fwd decls/aliases
//
#include "rw/rw_sb.hpp"  // spcly. #include'd before other RW classes
//
#include "action/action_sb.hpp"
#include "animeyes/animeyes_sb.hpp"
#include "arigato/arigato_sb.hpp"
#include "atashi/atashi_sb.hpp"
#include "bones/bones_sb.hpp"
#include "chibitsu/chibitsu_sb.hpp"
#include "curator/curator_sb.hpp"
#include "dollhouse/dollhouse_sb.hpp"
#include "electro/electro_sb.hpp"
#include "gears/gears_sb.hpp"
#include "graphicom/graphicom_sb.hpp"
#include "hearsay/hearsay_sb.hpp"
#include "meido/meido_sb.hpp"
#include "rw/sysutil_sb.hpp"
#include "shell/shell_sb.hpp"

//------------------------------------------------------------------------------
// THE RW 'SWITCHBOARD:B' - library header includes
//
#include "rw/rw_incls_all.hpp"  // spcly. #include'd before other RW classes
//
#include "action/action_incls_all.hpp"
#include "animeyes/animeyes_incls_all.hpp"
#include "arigato/arigato_incls_all.hpp"
#include "atashi/atashi_incls_all.hpp"
#include "bones/bones_incls_all.hpp"
#include "chibitsu/chibitsu_incls_all.hpp"
#include "curator/curator_incls_all.hpp"
#include "dollhouse/dollhouse_incls_all.hpp"
#include "electro/electro_incls_all.hpp"
#include "gears/gears_incls_all.hpp"
#include "graphicom/graphicom_incls_all.hpp"
#include "hearsay/hearsay_incls_all.hpp"
#include "meido/meido_incls_all.hpp"
#include "shell/shell_incls_all.hpp"
//
#include "rw/sysutil_incls_all.hpp"  // spcly. #include'd after other RW classes

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v221022
// Copyright (2022)
// License MIT(Expat) https://opensource.org/licenses/MIT
