//   RW Pandora
// ==============
// Demonstration of an Arigato-grade robowaifu
// -Part of the RW Foundations suite of libraries

// Filename: ./src/arigato/pandora.cpp
// -Definitions of the baseline RW Pandora project subsystem

#include "incls_all.hpp"

namespace rw::arigato {

//------------------------------------------------------------------------------
Pandora_b::Pandora_b() : Pandora_b{"pandora_b_obj"} {}

//------------------------------------------------------------------------------
Pandora_b::Pandora_b(std::string const& handle) : Arigato{handle} {
  stamp("Pandora_b()");
}

//------------------------------------------------------------------------------
Pandora::Pandora() : Pandora{"pandora_obj"} {}

//------------------------------------------------------------------------------
Pandora::Pandora(std::string const& handle) : Pandora_b{handle} {
  stamp("Pandora()");
}

//------------------------------------------------------------------------------
auto Pandora::do_preflight() -> bool {
  stamp("do_preflight()");

  // TODO:
  // do actual initialization here. eg, turn off embedded object's unneeded
  // members, ensure filesets are available & ready, connections are working,
  // etc., etc., etc.  :^)
  //

  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // STATUS:
  cout << ' ' << hdl() << " checks out A-OK!\n";
  return true;  // TEMP:
}

}  // namespace rw::arigato

//    --=^=--

// "______"

// rw_arigato_lib.v221022
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
