//   RW Catalog
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./src/curator/bumpmaster/catalog.cpp
// -Definitions of the baseline RW Catalog sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
Catalog_b::Catalog_b(Hip const& tag, std::string const& handle)
    : RW_slave{{Type::Bumpmaster}, handle} {
  stamp("Catalog_b()");

  bind_master(tag);
}

//------------------------------------------------------------------------------
auto Catalog_b::parse_threads_g(
    Hip const& tag /*, std::vector<Thread> threads*/) -> int {
  stamp(tag, "parse_threads_g()");

  if (tag == master()) {  // function is meant only for slave's Master to use
    // TODO:
    // ...
    // threads.emplace_back(thrd);
    // ...

    // return threads.size();
    return 1;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Catalog_b::parse_threads()");

  ///
  return 9'001'42;  // shouldn't reach here
}
// public wrapper for Master's use only
auto Catalog_b::parse_threads() -> int {
  return parse_threads_g(master());
}

//------------------------------------------------------------------------------
auto Catalog_b::have_new_g(Hip const& tag /*, std::vector<Thread> threads*/)
    -> bool {
  stamp(tag, "have_new_g()");

  if (tag == master()) {  // function is meant only for slave's Master to use
    // TODO:
    // ...

    return true;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Catalog_b::have_new()");

  ///
  return false;  // shouldn't reach here
}
// public wrapper for Master's use only
auto Catalog_b::have_new() -> bool {
  return have_new_g(master());
}

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v221022
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
