//   RW Dollnet
// ==============
// External, Inter-Networking Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/dollhouse/net/dollnet.cpp
// -Definitions of the baseline RW Dollnet sub-library

///////
// Dolldrop/Dollnet is meant for network-enabled RW projects only
#if __has_include(<curl/curl.h>)

#include "incls_all.hpp"

#include <curl/curl.h>

#include "dollnet_util.cpp"

namespace rw::dollhouse::net {

//------------------------------------------------------------------------------
Dolldrop_b::Dollnet::Dollnet(Hip const& tag, std::string const& handle)
    : RW_slave{{Type::Dolldrop}, handle} {
  stamp("Dollnet()");

  bind_master(tag);
}

//------------------------------------------------------------------------------
void Dolldrop_b::Dollnet::curl_pull_list(fs::path const& list_path) {
  stamp("curl_pull_list()");

  stringstream curl_cmdss;

  curl_cmdss << "xargs < " << list_path.string()
             << " curl --location --parallel --retry 6 --retry-max-time 62 "
                "--retry-all-errors --user-agent Bumpmaster_v221022";

  cout << flush;
  std::system(curl_cmdss.str().c_str());  // execute the above UNIX command
  //
  // TODO: derive return value for success w/ this specific std::system() call
}

}  // namespace rw::dollhouse::net

#endif  // __has_include(<curl/curl.h>)

//    --=^=--

// "This apartment has ultra-high bandwidth illegal even to large corporations?"

// rw_dollhouse_lib.v221022
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
